#include "MyException.h"

template <class T> 
class Repository{
private:
	int dim;
	int capacity;
	T* elements;
public:
	Repository();
	Repository(int c);
	Repository(Repository<T> &r);
	~Repository();
	Repository<T>& operator=(Repository<T> &r);
	void addElem(T el);
	T getElem(int pos);
	bool searchElem(T el);
	void deleteElem(T el);
	void updateElem(T el1, T el2);
	T* getAll();
	int getSize();
};

template <class T> Repository<T>::Repository(){
	dim = 0;
	capacity = 0;
	elements = NULL;
}
template <class T> Repository<T>::Repository(int c){
	dim = 0;
	capacity = c;
	elements = new T[c];
}

template <class T> Repository<T>::Repository(Repository<T> &r){
	dim = r.dim;
	capacity = r.capacity;
	elements = new T[capacity];
	for (int i = 0; i < dim; i++)
		elements[i] = r.elements[i];
}
template <class T> Repository<T>::~Repository(){
	if (elements != NULL){
		delete[] elements;
		elements = NULL;
	}
}
template <class T> Repository<T>& Repository<T>::operator=(Repository<T> &r){
	dim = r.dim;
	capacity = r.capacity;
	if (elements != NULL)
		delete[] elements;
	elements = new T[capacity];
	for (int i = 0; i < dim; i++)
		elements[i] = r.elements[i];
	return *this;
}
template <class T> void Repository<T>::addElem(T el){
	if (dim == capacity){
		throw MyException("the repo is full...");
	}
	else{
		if (searchElem(el))
			throw MyException("this elem was already stored...");
		else
			elements[dim++] = el;
	}
}
template <class T> T Repository<T>::getElem(int pos){
	if ((pos < 0) || (pos >= dim)){
		throw MyException("index out of bounds...");
	}
	else{
		return elements[pos];
	}
}
template <class T> bool Repository<T>::searchElem(T el){
	for (int i = 0; i < dim; i++)
	if (elements[i] == el)
		return true;
	return false;
}
template <class T> void Repository<T>::deleteElem(T el){
	int i = 0;
	while (i < dim){
		if (elements[i] == el){
			for (int j = i + 1; j < dim; j++)
				elements[j - 1] = elements[j];
			dim--;
		}
		else{
			i++;
		}
	}
}
template <class T> void Repository<T>::updateElem(T el1, T el2){
	for (int i = 0; i < dim; i++){
		if (elements[i] == el1)
			elements[i] = el2;
	}
}
template <class T> T* Repository<T>::getAll(){
	return elements;
}
template <class T> int Repository<T>::getSize(){
	return dim;
}
